/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.batch.functionsample.sample000;

import java.util.Date;
import java.util.Random;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import jp.terasoluna.fw.batch.openapi.BLogicResult;
import jp.terasoluna.fw.batch.openapi.ReturnCode;
import jp.terasoluna.fw.batch.openapi.SupportLogic;
import jp.terasoluna.fw.dao.UpdateDAO;
import jp.terasoluna.batch.functionsample.common.NyusyukkinData;

/**
 * サポートクラス。<br>
 * 入出金テーブルのデータをクリアし、新規データを作成する。<br>
 * <ul>
 * <li>ID:1〜ジョブコンテキストに設定した作成件数を順に設定</li>
 * <li>支店コード：1〜6をランダムで設定</li>
 * <li>入出金コード：0〜1をランダムで設定</li>
 * <li>取引コード：0〜3をランダムで設定</li>
 * <li>顧客コード: 0000000001から順に設定</li>
 * <li>取引金額：1〜1000000をランダムで設定</li>
 * </ul>
 */
public class Sample000PreLogic implements SupportLogic<Sample000JobContext> {

    /**
     * ログクラス。
     */
    private static final Log log = LogFactory.getLog(Sample000PreLogic.class);
        
    /**
     * DAOクラス。
     * Springによりインスタンス生成され設定される。
     */
    private UpdateDAO updateDAO;
    
    /**
     * 処理を起動する。
     */
    public BLogicResult execute(Sample000JobContext jobContext) {

    if(log.isDebugEnabled()){
        log.debug("start.");
    }
    
    //入出金テーブルのデータをクリア
    updateDAO.execute("SAMPLE000.deleteNyusyukkin", null);
     
    Random random = new Random();
    NyusyukkinData nyusyukkin = new NyusyukkinData();
    Date torihikibi = new Date(System.currentTimeMillis());
    
    int maxNumber = jobContext.getMaxNumber();
    for(int count = 1; count <= maxNumber; count++){
     
        int sitenCd = random.nextInt(6) + 1;
        int nyusyukkinCd = random.nextInt(2);
        int torihikiCd = random.nextInt(4);
        int kokyakuCd = count;
        int kingaku = random.nextInt(1000000) + 1;
        
        nyusyukkin.setId(count);
        nyusyukkin.setNyusyukkincd(nyusyukkinCd);
        nyusyukkin.setTorihikicd(torihikiCd);
        nyusyukkin.setSitencd(String.valueOf(sitenCd));
        nyusyukkin.setKokyakucd(String.format("%010d", kokyakuCd));
        nyusyukkin.setKingaku(kingaku);
        nyusyukkin.setTorihikibi(torihikibi);
        
        //データ作成
        updateDAO.execute("SAMPLE000.insertNyusyukkin", nyusyukkin);
    }

    if(log.isDebugEnabled()){
        log.debug("end.");
    }
    
    return new BLogicResult(ReturnCode.NORMAL_CONTINUE);
    }

    /**
     * UpdateDAOを設定する。
     * @param updateDAO 設定するUpdateDAO
     */
    public void setUpdateDAO(UpdateDAO updateDAO) {
        this.updateDAO = updateDAO;
    }
    

}
